<?php 
class ControllerExtensionPaymentIdealcheckoutafterpay extends Controller 
{
	private $error = array(); 

	public function index() 
	{

		$this->load->language('extension/payment/idealcheckoutafterpay');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if(($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) 
		{
			$this->model_setting_setting->editSetting('idealcheckoutafterpay', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');
		
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['entry_order_success_status'] = $this->language->get('entry_order_success_status');
        $data['entry_order_pending_status'] = $this->language->get('entry_order_pending_status');
        $data['entry_order_cancel_status'] = $this->language->get('entry_order_cancel_status');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');
		
		if(isset($this->error['warning']))
		{
			$data['error_warning'] = $this->error['warning'];
		}
		else
		{
			$data['error_warning'] = '';
		}

        if(isset($this->request->post['idealcheckoutafterpay_order_success_status_id']))
		{
            $data['idealcheckoutafterpay_order_success_status_id'] = $this->request->post['idealcheckoutafterpay_order_success_status_id'];
        }
		else
		{
            $data['idealcheckoutafterpay_order_success_status_id'] = $this->config->get('idealcheckoutafterpay_order_success_status_id');
        }

        if(isset($this->request->post['idealcheckoutafterpay_order_pending_status_id']))
		{
            $data['idealcheckoutafterpay_order_pending_status_id'] = $this->request->post['idealcheckoutafterpay_order_pending_status_id'];
        }
		else
		{
            $data['idealcheckoutafterpay_order_pending_status_id'] = $this->config->get('idealcheckoutafterpay_order_pending_status_id');
        }

        if(isset($this->request->post['idealcheckoutafterpay_order_cancel_status_id']))
		{
            $data['idealcheckoutafterpay_order_cancel_status_id'] = $this->request->post['idealcheckoutafterpay_order_cancel_status_id'];
        }
		else
		{
            $data['idealcheckoutafterpay_order_cancel_status_id'] = $this->config->get('idealcheckoutafterpay_order_cancel_status_id');
        }

        $this->load->model('localisation/order_status');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$data['breadcrumbs'] = array();


   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], true),
      		'separator' => false
   		);
		
   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true),      		
      		'separator' => ' :: '
   		);
		
   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/payment/idealcheckoutafterpay', 'token=' . $this->session->data['token'], true),
      		'separator' => ' :: '
   		);

		
		$data['action'] = $this->url->link('extension/payment/idealcheckoutafterpay', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true);	
				
		if(isset($this->request->post['idealcheckoutafterpay_status'])) 
		{
			$data['idealcheckoutafterpay_status'] = $this->request->post['idealcheckoutafterpay_status'];
		}
		else 
		{
			$data['idealcheckoutafterpay_status'] = $this->config->get('idealcheckoutafterpay_status');
		}

		if(isset($this->request->post['idealcheckoutafterpay_sort_order'])) 
		{
			$data['idealcheckoutafterpay_sort_order'] = $this->request->post['idealcheckoutafterpay_sort_order'];
		}
		else 
		{
			$data['idealcheckoutafterpay_sort_order'] = $this->config->get('idealcheckoutafterpay_sort_order');
		}


		$this->template = 'extension/payment/idealcheckoutafterpay.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/idealcheckoutafterpay.tpl', $data));
	}

	private function validate() 
	{
		if(!$this->user->hasPermission('modify', 'extension/payment/idealcheckoutafterpay'))
		{
			$this->error['warning'] = $this->language->get('error_permission');
		}
				
		if(!$this->error)
		{
			return true;
		}
		else
		{
			return false;
		}	
	}
}

?>